loadpat  .block
         lda fnlen
         ldx #<fn
         ldy #>fn
         jsr $ffbd    ;setnam
         lda #8
         jsr io2
         jsr $ffc0    ;open file
         ldx #8
         jsr $ffc6    ;open channel
         bcs error

         ldy #0
loop4    jsr $ffb7    ;read st
         bne checkst

         jsr $ffcf
         cmp #193
         bcs eof

         sta x0,y     ;geometry
         iny
         cpy #2
         bne loop4

         jsr showrect
         bcs eof
 
         ldy #0
loop2    jsr $ffb7    ;read st
         bne checkst

         jsr $ffcf    ;read byte
         sta $fe8,y   ;live/born
         iny
         cpy #4
         bne loop2
         
         lda $fe9
         ora $feb
         cmp #2
         bcs eof

         lda $fea
         and #1
         bne eof

         ldy #3
loop1    lda live,y
         cmp $fe8,y
         bne cont1

         dey
         bpl loop1

loop5    ldy #0
loop6    jsr $ffb7    ;read st
         bne checkst

         jsr $ffcf    
         sta x0,y   ;x,y - data
         iny
         cpy #2
         bne loop6

         jsr putpixel
         jmp loop5

checkst  cmp #$40
         bne error
         beq eof

error    jsr showds
         lda #0
         sta fnlen
eof      jmp endio

cont1    ldy #3
loop3    lda $fe8,y
         sta live,y
         dey
         bpl loop3

         jsr fillrt   ;sets ZF=1
         beq loop5
         .bend

showds   .block
         lda #147
         jsr $ffd2
         lda #0
         jsr $ffbd
         lda #15
         ldx $ae
         tay
         jsr $ffba
         jsr $ffc0
         ldx #15
         jsr $ffc6
loop7    jsr $ffb7
         bne eof15
         
         jsr $ffcf
         jsr $ffd2
         jmp loop7

eof15    lda #15
         jsr $ffc3
         jmp getkey
         .bend

showdir  .block
         jsr dirop1
         BCS error

         LDY #6
skip6    JSR getbyte    ; get a byte from dir and ignore it
         DEY
         BNE skip6

         lda #$9c
         jsr $ffd2
loop1    jsr getbyte
         beq cont5
         
         jsr $ffd2
         jmp loop1 

cont5    lda #$d
         jsr $ffd2
next     LDY #2         ; skip 2 bytes on all other lines
skip2    JSR getbyte    ; get a byte from dir and ignore it
         DEY
         BNE skip2

         JSR getbyte    ; get low byte of filesize
         sta fileszlo
         JSR getbyte    ; get high byte
         sta fileszhi
         jsr getbyte
         cmp #$42
         beq prfree

         jsr printmi
         beq exit

         lda #2
         sta quotest
         LDA #$20       ;print a space first
char     cmp #$22       ;quote
         bne cont1
 
         dec quotest
         beq cont4

cont1    ldx quotest
         beq cont3

         cpx #2
         beq cont3

cont4    JSR $FFD2
cont3    JSR getbyte
         BNE char       ; continue until end of line

         jsr printsz
         JSR $FFE1      ; RUN/STOP pressed?
         BNE next       ; no RUN/STOP -> continue
         beq exit

error    jsr showds
exit     jmp endio

getbyte  JSR $FFB7      ; call READST (read status byte)
         BNE end

         JMP $FFCF      ; call CHRIN (read byte from directory)

end      PLA            ; don't return to dir reading loop
         PLA
         JMP exit

prfree   jsr $ff4f
         .byte 144,0
         lda fileszhi
         ldx fileszlo
         jsr $a45f      ;int -> str
         lda #$ff
         sta quotest
         jsr $ff4f
         .byte 32,0
         lda #$42
         bne cont4
         .bend

menucnt  = $ffb
quotest  = $ffe
fileszhi = $ffd  
fileszlo = $ffc

printmi  .block
         lda #28
         jsr $ffd2
         ldx menucnt
         cpx #100
         bcs cont

         cpx #10
         bcs cont2

         lda #32
         jsr $ffd2
cont2    lda #32
         jsr $ffd2

cont     lda #0
         jsr $a45f
         jsr $ff4f
         .byte 144,32,0
         inc menucnt
         rts
         .bend

skipln  .block
        JSR $FFB7      ; call READST (read status byte)
        BNE end

        jsr $FFCF
        DEY
        BNE skipln

char    JSR $FFB7      ; call READST (read status byte)
        BNE end    

        jsr $FFCF
        BNE char       ; continue until end of line

end     rts
        .bend

printsz .block
        lda quotest
        bmi exit

        jsr $ff4f
        .byte 32,31,0
        lda fileszhi
        ldx fileszlo
        JSR $a45f
        lda #144
        jsr $ffd2
exit    lda #$d
        jmp $ffd2
        .bend

dirop1   LDA dirnlen
         LDX #<dirname
         LDY #>dirname
         JSR $FFBD      ; call SETNAM
         LDA #8
         LDY #0         ; secondary address 0 (required for dir reading!)
         sty menucnt
         jsr io1
         jsr $FFC0      ;call OPEN (open the directory)
         bcs error1     ; quit if OPEN failed

         LDX #8         ; filenumber 8
         JSR $FFC6      ; call CHKIN
error1   rts

findfn   .block         ;fn# is at $14-15
         jsr dirop1
         BCS error

         LDY #6
         jsr skipln
         bne error

         lda $14
         beq next

loop0    ldy #4
         jsr skipln
         bne error

         dec $14
         bne loop0

next     LDY #4
skip2    JSR getbyte    ; get a byte from dir and ignore it
         DEY
         BNE skip2

         lda #2
         sta quotest
char     cmp #$22       ;quote
         bne cont1
 
         dec quotest
         beq exit
         bne cont3

cont1    ldx quotest
         cpx #2
         beq cont3

cont4    ldy menucnt
         sta fn,y
         inc menucnt
cont3    JSR getbyte
         BNE char       ; continue until end of line

         beq exit

error    jsr showds
exit     lda menucnt
         sta fnlen
         jmp endio

getbyte  JSR $FFB7      ; call READST (read status byte)
         BNE end

         JMP $FFCF      ; call CHRIN (read byte from directory)

end      PLA            ; don't return to dir reading loop
         PLA
         JMP exit
         .bend

savepat  .block
sizex    = adjcell2
sizey    = adjcell2+1
xmin     = i1
ymin     = i1+1
curx     = adjcell
cury     = adjcell+1
         lda #8
         jsr io2
         ldy svfnlen
         lda #","
         sta svfn,y
         sta svfn+2,y
         lda #"u"
         sta svfn+1,y
         lda #"w"
         sta svfn+3,y
         tya
         clc
         adc #4
         ldx #<svfn
         ldy #>svfn
         jsr $ffbd    ;setnam
         jsr $ffc0    ;open file
         ldx #8
         jsr $ffc9    ;open channel for write
         bcs error

         jsr $ffb7    ;read st
         bne error

         lda sizex
         jsr $ffd2
         jsr $ffb7    ;read st
         bne error

         lda sizey
         jsr $ffd2
         ldy #0
loop1    jsr $ffb7    ;read st
         bne error

         lda live,y
         jsr $ffd2
         iny
         cpy #4
         bne loop1
         
         lda #0
         sta curx
         sta cury
         lda #<tiles ;=0
         sta currp
         lda #>tiles
         sta currp+1
loop0    ldy #0
loop2    sei
         sta $ff3f
         lda (currp),y
         sta $ff3e
         cli
         bne cont1

loop4    iny
         cpy #8
         bne loop2

         jsr inccurrp
         inc curx
         ldx curx
         cpx #20
         bne loop0

         ldx #0
         stx curx
         inc cury
         ldy cury
         cpy #24
         bne loop0
         beq eof

error    jsr $ffcc
         jsr showds
eof      jmp endio

cont1    ldx #$ff
loop3    inx
         asl
         bcs cont4
         beq loop4
         bcc loop3
         
cont4    sta i2
         stx t1
         jsr $ffb7    ;read st
         bne error

         lda curx
         asl
         asl
         asl
         adc t1
         sec
         sbc xmin
         jsr $ffd2
         jsr $ffb7    ;read st
         bne error

         sty t1
         lda cury
         asl
         asl
         asl
         adc t1
         sec
         sbc ymin
         jsr $ffd2
         lda i2
         jmp loop3
         .bend

showcomm .block
         ldx fnlen
         lda #"#"
         cpx #16
         beq cont1

         inx
cont1    sta fn-1,x
         txa
         ldx #<fn
         ldy #>fn
         .bend

showtxt  .block
         jsr $ffbd    ;setnam
         lda #8
         jsr io2
         jsr $ffc0    ;open file
         ldx #8
         jsr $ffc6    ;open channel
         bcs error

         lda #8
         sta $ff07
         jsr $ff4f
         .byte 147,144,0

loop6    jsr $ffb7    ;read st
         bne checkst

         jsr $ffcf
         bne cont2

         JSR $FFE1      ; RUN/STOP pressed?
         beq eof

         lda #$d
cont2    jsr $ffd2
         jmp loop6

checkst  cmp #$40
         beq eof

error    jsr showds
         bne endio

eof      jsr getkey
         lda #$8e
         jsr $ffd2
         .bend

endio    jsr $FFCC      ;must be after showcomm!
         LDA #8         ; filenumber 8
         jmp $FFC3      ; call CLOSE

savecf   .block
         lda #0
         jsr io2
         lda #cfnlen+3
         ldx #<cfn
         ldy #>cfn
         jsr $ffbd    ;setnam
         lda #<borderpc
         sta i1
         lda #>borderpc
         sta i1+1
         ldx #<topology
         ldy #>topology
         lda #<i1
         jsr $ffd8
         bcc noerror

         jsr showds
noerror  rts
         .bend

loadcf   .block
         lda #1
         jsr io2
         lda #cfnlen
         ldx #<cfn+3
         ldy #>cfn+3
         jsr $ffbd    ;setnam
         lda #0
         jmp $ffd5
         .bend

